#pragma once


//Implement application-level callbacks for the browser process. //CEF_INTEGRATION
class CCEFAppHandler : public CefApp, public CefBrowserProcessHandler
{
  CefRefPtr<CefBrowserProcessHandler> GetBrowserProcessHandler() override
  {
    return this;
  }

protected:
  //Include the default reference counting implementation
  IMPLEMENT_REFCOUNTING(CCEFAppHandler);
};


class CCEFDemoApp : public CWinApp
{
public:
//Constructors / Destructors
  CCEFDemoApp() noexcept;

//Methods
  BOOL InitInstance() override;
  int ExitInstance() override;
  BOOL PumpMessage() override; //CEF_INTEGRATION
  static bool TryLoadAllImports(_In_z_ LPCSTR szDll) noexcept; //CEF_INTEGRATION

//Member variables
  //CEF_INTEGRATION
  bool InitializeCef();
  CefRefPtr<CCEFAppHandler> m_CefApp;
  bool m_bDidCefInitialize;

//Message handlers
  afx_msg void OnAppAbout();

  DECLARE_MESSAGE_MAP()
};
