#include "stdafx.h"
#include "CEFDemo.h"
#include "CEFDemoDoc.h"
#include "CEFDemoView.h"
#include "MainFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26409 26433 26440 26477)
IMPLEMENT_DYNCREATE(CCEFDemoView, CCEFView)

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CCEFDemoView, CCEFView) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
END_MESSAGE_MAP()


#pragma warning(suppress: 26439 26455)
CCEFDemoView::CCEFDemoView() : m_BeforeFullScreenPlacement{}
{
}

#pragma warning(suppress: 26434 26440)
CCEFDemoDoc* CCEFDemoView::GetDocument()
{
  ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCEFDemoDoc)));
#pragma warning(suppress: 26466)
  return static_cast<CCEFDemoDoc*>(m_pDocument);
}

//CEF_INTEGRATION
void CCEFDemoView::OnSetAddress(_Inout_ CefRefPtr<CefBrowser> /*browser*/, _Inout_ CefRefPtr<CefFrame> /*frame*/, _In_ const std::string& url)
{
  m_sURL = CString{CefString{url}.ToWString().c_str()};
#pragma warning(suppress: 26429 26466)
  auto pMain{static_cast<CMainFrame*>(AfxGetMainWnd())};
  ASSERT(pMain != nullptr);
  const auto* pFrame{pMain->GetActiveFrame()}; //NOLINT(clang-analyzer-core.CallAndMessage)
  if (pFrame == nullptr)
    return;
#pragma warning(suppress: 26462)
  auto* pView{pFrame->GetActiveView()};
  if (pView == this)
    pMain->SetUrl(m_sURL);
}

//CEF_INTEGRATION
void CCEFDemoView::OnSetTitle(_Inout_ CefRefPtr<CefBrowser> /*browser*/, _In_ const std::string& title)
{
  GetDocument()->SetTitle(CString{CefString{title}.ToWString().c_str()});
}

//CEF_INTEGRATION
void CCEFDemoView::Toggle(_In_ HWND hWndRoot, _In_ UINT nCmdShow) noexcept
{
  //Retrieve current window placement information
  WINDOWPLACEMENT placement{};
  ::GetWindowPlacement(hWndRoot, &placement);
  if (placement.showCmd == nCmdShow)
    ::ShowWindow(hWndRoot, SW_RESTORE);
  else
    ::ShowWindow(hWndRoot, nCmdShow);
}

//CEF_INTEGRATION
void CCEFDemoView::OnFullscreenModeChange(_Inout_ CefRefPtr<CefBrowser> /*browser*/, _In_ bool fullscreen)
{
#pragma warning(suppress: 26429 26466)
  auto* pMain{static_cast<CMainFrame*>(AfxGetMainWnd())};
  ASSERT(pMain != nullptr);
  if (fullscreen)
  {
#pragma warning(suppress: 26429)
    CWnd* pParentFrame{GetParentFrame()};
    ASSERT(pParentFrame != nullptr);
    pParentFrame->GetWindowPlacement(&m_BeforeFullScreenPlacement);
    pMain->MDIMaximize(pParentFrame); //NOLINT(clang-analyzer-core.CallAndMessage)
    Toggle(pMain->GetSafeHwnd(), SW_MAXIMIZE);
  }
  else
  {
#pragma warning(suppress: 26429)
    CWnd* pParentFrame{GetParentFrame()};
    ASSERT(pParentFrame != nullptr);
    pParentFrame->SetWindowPlacement(&m_BeforeFullScreenPlacement);
    pMain->ShowWindow(SW_RESTORE); //NOLINT(clang-analyzer-core.CallAndMessage)
  }
}

//CEF_INTEGRATION
void CCEFDemoView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView)
{
  __super::OnActivateView(bActivate, pActivateView, pDeactiveView);

  //Update the mainframe's address details anytime we switch to a CEF view
  if (pActivateView == nullptr)
    return;
  if (!pActivateView->IsKindOf(RUNTIME_CLASS(CCEFDemoView)))
    return;
#pragma warning(suppress: 26466)
  const auto* pView{static_cast<CCEFDemoView*>(pActivateView)};
#pragma warning(suppress: 26429 26466)
  auto* pMain{static_cast<CMainFrame*>(AfxGetMainWnd())};
  ASSERT(pMain != nullptr);
  pMain->SetUrl(pView->m_sURL); //NOLINT(clang-analyzer-core.CallAndMessage)
}

//CEF_INTEGRATION
#pragma warning(suppress: 26434)
void CCEFDemoView::OnInitialUpdate()
{
  __super ::OnInitialUpdate();
#pragma warning(disable:26409)
  SetupClientHandler(new CCEFDemoClientHandler{this});
}
