#include "stdafx.h"
#include "CEFWrappers.h"
#include "MainFrm.h"
#include "CEFDemoView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CEditAddress, CEdit) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
  ON_CONTROL_REFLECT(CBN_SELCHANGE, &CEditAddress::OnCbnSelchange)
END_MESSAGE_MAP()

void CEditAddress::OnCbnSelchange()
{
  AfxGetMainWnd()->PostMessage(WM_COMMAND, ID_BUTTON_GO);
}

void CEditAddress::RememberURL(_In_ const CString& sURL)
{
  if (!sURL.IsEmpty())
  {
    if (FindStringExact(0, sURL) == CB_ERR)
      AddString(sURL);
  }
}

BOOL CEditAddress::PreTranslateMessage(MSG* pMsg)
{
  if ((pMsg->message == WM_KEYDOWN) && LOWORD(pMsg->wParam) == VK_RETURN)
  {
    AfxGetMainWnd()->PostMessage(WM_COMMAND, ID_BUTTON_GO);
    return TRUE;
  }
  else
    return __super::PreTranslateMessage(pMsg);
}

#pragma warning(suppress: 26409 26433 26440 26477)
IMPLEMENT_DYNCREATE(CMainFrame, CMDIFrameWnd)

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_CREATE()
  ON_WM_CLOSE()
  ON_COMMAND(ID_BUTTON_BACK, &CMainFrame::OnGoBack)
  ON_COMMAND(ID_BUTTON_GO, &CMainFrame::OnGo)
  ON_COMMAND(ID_BUTTON_FORWARD, &CMainFrame::OnGoForward)
  ON_UPDATE_COMMAND_UI(ID_BUTTON_BACK, &CMainFrame::OnUpdateGoBack)
  ON_UPDATE_COMMAND_UI(ID_BUTTON_GO, &CMainFrame::OnUpdateGo)
  ON_UPDATE_COMMAND_UI(ID_BUTTON_FORWARD, &CMainFrame::OnUpdateGoForward)
END_MESSAGE_MAP()

std::array<UINT, 1> g_Indicators
{
  ID_SEPARATOR //status line indicator
};

#pragma warning(suppress: 26434)
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  //Let the base class do its thing
  if (__super::OnCreate(lpCreateStruct) == -1)
    return -1;

  //Create the toolbar
  if (!m_wndToolBar.Create(this) || !m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
  {
    TRACE(_T("Failed to create toolbar\n"));
    return -1;
  }

  //Set the title of the toolbar
  CString sTitle;
  VERIFY(sTitle.LoadString(IDS_TOOLBAR));
  m_wndToolBar.SetWindowText(sTitle);

  //Create the status bar
  #pragma warning(suppress: 26472)
  if (!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(g_Indicators.data(), static_cast<int>(g_Indicators.size())))
  {
    TRACE(_T("Failed to create status bar\n"));
    return -1;
  }

  //Setup docking
  m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
  EnableDocking(CBRS_ALIGN_ANY);
  DockControlBar(&m_wndToolBar);

  //Set up the edit control as a snap mode select box
  //First get the index of the place holder's position in the toolbar
  int nIndex{0};
  while (m_wndToolBar.GetItemID(nIndex) != ID_ADDRESS_CONTROL)
    ++nIndex;
  //Next convert that button to a separator and get its position
  m_wndToolBar.SetButtonInfo(nIndex, ID_ADDRESS_CONTROL, TBBS_SEPARATOR, 600);
  CRect rect;
  m_wndToolBar.GetItemRect(nIndex, &rect);
  rect.bottom += 250;
  //Then .Create the edit box and show it
  if (!m_wndToolBar.m_wndAddress.Create(WS_CHILD | WS_VISIBLE | CBS_AUTOHSCROLL | CBS_DROPDOWN | CBS_HASSTRINGS, rect, &m_wndToolBar, IDC_EDIT_ADDRESS))
  {
    TRACE(_T("Failed to create address control\n"));
    return FALSE;
  }
  m_wndToolBar.m_wndAddress.SetFont(m_wndStatusBar.GetFont());
  m_wndToolBar.m_wndAddress.ShowWindow(SW_SHOW);

  return 0;
}

//CEF_INTEGRATION
void CMainFrame::OnGo()
{
  auto* view{GetActiveCEFView()};
  if (view != nullptr)
  {
    CString sURL;
    m_wndToolBar.m_wndAddress.GetWindowText(sURL);
    m_wndToolBar.m_wndAddress.RememberURL(sURL);
    view->Navigate(sURL);
  }
}

//CEF_INTEGRATION
void CMainFrame::OnGoBack()
{
  auto* view{GetActiveCEFView()};
  if (view != nullptr)
    view->NavigateBack();
}

//CEF_INTEGRATION
void CMainFrame::OnGoForward()
{
  auto* view{GetActiveCEFView()};
  if (view != nullptr)
    view->NavigateForward();
}

//CEF_INTEGRATION
#pragma warning(suppress: 26429)
void CMainFrame::OnUpdateGo(CCmdUI* pCmdUI)
{
  CString sURL;
  m_wndToolBar.m_wndAddress.GetWindowText(sURL);
#pragma warning(suppress: 26486)
  pCmdUI->Enable(!sURL.IsEmpty() ? TRUE : FALSE);
}

//CEF_INTEGRATION
#pragma warning(suppress: 26440 26429)
void CMainFrame::OnUpdateGoBack(CCmdUI* pCmdUI)
{
  auto* view{GetActiveCEFView()};
#pragma warning(suppress: 26486)
  pCmdUI->Enable((view != nullptr) && view->CanNavigateBack());
}

//CEF_INTEGRATION
#pragma warning(suppress: 26440 26429)
void CMainFrame::OnUpdateGoForward(CCmdUI* pCmdUI)
{
  auto* view{GetActiveCEFView()};
#pragma warning(suppress: 26486)
  pCmdUI->Enable((view != nullptr) && view->CanNavigateForward());
}

//CEF_INTEGRATION
#pragma warning(suppress: 26440)
void CMainFrame::SetUrl(const CString& sURL)
{
  m_wndToolBar.m_wndAddress.SetWindowText(sURL);
  m_wndToolBar.m_wndAddress.RememberURL(sURL);
}

CCEFView* CMainFrame::GetActiveCEFView()
{
  const auto* pFrame{GetActiveFrame()};
  if (pFrame == nullptr)
    return nullptr;
#pragma warning(suppress: 26429)
  auto* pView{pFrame->GetActiveView()};
  if (pView == nullptr)
    return nullptr;
  if (pView->IsKindOf(RUNTIME_CLASS(CCEFView)))
#pragma warning(suppress: 26466)
    return static_cast<CCEFView*>(pView);
  else
    return nullptr;
}

//CEF_INTEGRATION
#pragma warning(suppress: 26434)
void CMainFrame::OnClose()
{
#pragma warning(suppress: 26429)
  const auto* pApp{AfxGetApp()};
  ASSERT(pApp != nullptr);
  POSITION posDocTemplate{pApp->GetFirstDocTemplatePosition()};
  while (posDocTemplate != nullptr)
  {
#pragma warning(suppress: 26429)
    const auto* pTemplate{pApp->GetNextDocTemplate(posDocTemplate)};
    ASSERT(pTemplate != nullptr);
    POSITION posDoc{pTemplate->GetFirstDocPosition()};
    while (posDoc != nullptr)
    {
#pragma warning(suppress: 26429)
      const auto* pDocument{pTemplate->GetNextDoc(posDoc)};
      ASSERT(pDocument != nullptr);
#pragma warning(suppress: 26429)
      POSITION posView{pDocument->GetFirstViewPosition()};
      while (posView != nullptr)
      {
#pragma warning(suppress: 26429)
        auto* pView{pDocument->GetNextView(posView)};
        ASSERT(pView != nullptr);
        if (pView->IsKindOf(RUNTIME_CLASS(CCEFDemoView)))
        {
#pragma warning(suppress: 26429 26466)
          auto* pCEFDemoView{static_cast<CCEFDemoView*>(pView)};
          pCEFDemoView->CloseBrowser();
        }
      }
    }
  }

  __super::OnClose();
}
